/*Copyright (c) 2010 Maxime Petitjean

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.*/

#ifndef _MANDELBROT_H_
#define _MANDELBROT_H_

#include <QObject>
#include <../fractalplugin.h>

namespace Plugin
{

class MandelbrotSequence : public Sequence
{
private:
	Point m_constant_point;
public:
	virtual Point	init( const Point& _init_point );
	virtual Point	next( const Point& _point );
	virtual bool	end( const Point& _point );
};

class MandelbrotFractal : public QObject, public Fractal
{
	Q_OBJECT
	Q_INTERFACES(Plugin::Fractal)
	
public:
	virtual Sequence*	sequence()	const	{ return new MandelbrotSequence(); }

	virtual QString		name()		const	{ return "Mandelbrot Plugin"; }
	virtual QString		author()	const	{ return "Maxime Petitjean"; }
	virtual int			version()	const	{ return 100; }
	virtual QImage		image()		const	{ return QImage( ":/Mandelbrot/image.png" ); }
	virtual QString		text()		const;
};

}

#endif //_MANDELBROT_H_
