/*Copyright (c) 2010 Maxime Petitjean

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.*/

#ifndef _TEST_H_
#define _TEST_H_

#include <QObject>
#include <../fractalplugin.h>

namespace Plugin
{

class TestSequence : public Sequence
{
private:
	Point m_constant_point;
public:
	virtual Point	init( const Point& _init_point );
	virtual Point	next( const Point& _point );
	virtual bool	end( const Point& _point );
};

class TestFractal : public QObject, public Fractal
{
	Q_OBJECT
	Q_INTERFACES(Plugin::Fractal)

public:
	virtual Sequence*	sequence()	const	{ return new TestSequence(); }
	virtual PointsGeneratorType pointsGeneratorType() const { return RandomGenerator; }
	virtual AccumulatorType accumulatorType() const { return SequenceAccumulator; }

	virtual QString		name()		const	{ return "Test Plugin"; }
	virtual QString		author()	const	{ return "Maxime Petitjean"; }
	virtual int			version()	const	{ return 100; }
};

}

#endif //_TEST_H_
