/*Copyright (c) 2010 Maxime Petitjean

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.*/

#ifndef _PLUGINSEQUENCE_H_
#define _PLUGINSEQUENCE_H_

#include "../sequence.h"
#include "../../../plugin/fractalplugin.h"

#include <QtCore/QDir>

class PluginSequence : public Sequence
{
public:
	static Plugin::Fractal* fractal_plugin;

protected:
	Plugin::Sequence* m_sequence;

public:
	PluginSequence( const FractalParameters * _fractal_parameters )
		:	Sequence( _fractal_parameters )
	{
		m_sequence = fractal_plugin->sequence();
	}
	virtual ~PluginSequence()
	{
		Q_ASSERT( m_sequence != NULL );
		delete m_sequence;
	}

protected:
	virtual Point init( const Point& _init_point )
	{
		Q_ASSERT( m_sequence != NULL );
		return m_sequence->init( _init_point );
	}
	virtual Point next( const Point& _point )
	{
		Q_ASSERT( m_sequence != NULL );
		return m_sequence->next( _point );
	}
	virtual bool end( const Point& _point )
	{
		Q_ASSERT( m_sequence != NULL );
		return m_sequence->end( _point );
	}
};

#endif //_PLUGINSEQUENCE_H_
