#include "pluginmanager.h"

#include <QtCore/QPluginLoader>

void PluginManager::load( const QDir& _directory )
{
	foreach( QString filename, _directory.entryList( QDir::Files ) )
	{
		QPluginLoader loader( _directory.absoluteFilePath( filename ) );
		QObject *plugin = loader.instance();
		if( plugin )
		{
			Plugin::Fractal* fractal_plugin = qobject_cast<Plugin::Fractal *>( plugin );
			if( fractal_plugin )
			{
				QHash<QString, Plugin::Fractal*>::const_iterator it = m_plugins.find( fractal_plugin->name() );
				if( it == m_plugins.end() )
					m_plugins.insert( fractal_plugin->name(), fractal_plugin );
			}
		}
	}
}

Plugin::Fractal* PluginManager::plugin( const QString& _name )
{
	QHash< QString, Plugin::Fractal* >::const_iterator it = m_plugins.find( _name );
	if( it != m_plugins.end() )
		return it.value();
	return NULL;
}
